/******************************************************************************/
/******************************************************************************/
/*                                                                            */
/* Trigger: DTULTATU_BASE                                                     */
/* Tabela : BASE                                                              */
/*                                                                            */
/* Criao:                                                                   */
/* 23/01/2004 - Newton N. Santos                                              */
/*                                                                            */
/******************************************************************************/

CREATE OR REPLACE TRIGGER DTULTATU_BASE
BEFORE INSERT OR UPDATE OR DELETE
ON BASE FOR EACH ROW

BEGIN
   IF INSERTING THEN
      :NEW.DTULTATUBASE := SYSDATE;
   END IF;
   IF UPDATING THEN
      IF (NVL(:OLD.CDBASE,0) <> NVL(:NEW.CDBASE,0)) OR
         (NVL(:OLD.SGBASE,0) <> NVL(:NEW.SGBASE,0)) OR
         (NVL(:OLD.DSBASE,0) <> NVL(:NEW.DSBASE,0)) THEN
         :NEW.DTULTATUBASE := SYSDATE;
      END IF;
   END IF;
   IF DELETING THEN
      INSERT INTO DELETECACHE (NMTABLECACHE, CDFILICACHE, DSKEYCACHE, DTULTATUCACH)
                       VALUES ('BASE', '', 'CDBASE='||:OLD.CDBASE||';', SYSDATE);
   END IF;
END;
/

ALTER TABLE BASE MODIFY DTULTATUBASE DEFAULT SYSDATE
/
