<?php
namespace Zeedhi\DevOps\Model\Devops\Repositories;


class ProductVersionProducts extends \Doctrine\ORM\EntityRepository {
    
    public function getProductVersionsProducts($version){
        $query = <<<SQL
        SELECT DISTINCT PVP.ID, PVP.DEP_PRODUCT_VERSION_ID, PVP.PRODUCT_ID, 
               PVP.PRODUCT_VERSION_ID, PRO.NAME AS PRODUCT_NAME, 
               (PR.VERSION || '.' || PR.REVISION || '.' || PR.BUILD) AS VERSION
          FROM PRODUCT_VERSION_PRODUCTS PVP
          JOIN PRODUCT PRO ON PVP.PRODUCT_ID = PRO.ID 
          JOIN PRODUCT_VERSION PR ON PVP.DEP_PRODUCT_VERSION_ID = PR.ID
         WHERE PVP.PRODUCT_VERSION_ID = :version
SQL;
    
        $params = array(
			'version' => $version
		);

        return $this->getEntityManager()->getConnection()->fetchAll($query,$params);
    }

    
}